/***************************************************************************
                          kbgroup.h  -  description
                             -------------------
    begin                : Wed Jul 4 2001
    copyright            : (C) 2001 by Leonid Zeitlin
    email                : lz@europe.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBGROUP_H
#define KBGROUP_H

#include <qpixmap.h>
#include <qstring.h>

/**A helper class the holds keyboard group's name and pixmap
  *@author Leonid Zeitlin
  */

class KBGroup {
public: 
	KBGroup(const QString& name, const QString& lang);
	~KBGroup();
	/** */
	const QPixmap& getPixmap() { return m_pixmap; }
  /** No descriptions */
  const QString& getName() { return m_name; }
  const QString& getLang() { return m_lang; }
  /** No descriptions */
  void setPixmap(const QPixmap& pixmap) { m_pixmap = pixmap; }
  const QString& getIconPath() { return m_iconpath; }
  void setIconPath(const QString &iconpath) { m_iconpath = iconpath; }
private: // Private attributes
  /**  */
  QString m_name;
  QString m_lang;
  /**  */
  QPixmap m_pixmap;
  QString m_iconpath;
};

#endif
