/***************************************************************************
                          kbswitchintf.cpp  -  description
                             -------------------
    begin                : Sun Aug 12 2001
    copyright            : (C) 2001 by Leonid Zeitlin
    email                : lz@europe.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kbswitchintf.h"
//#include <kapp.h>

KBSwitchIntf::KBSwitchIntf(QObject *parent, KBConfig *conf)
  : QObject(parent, "KBSwitchIntf"), DCOPObject("KBSwitchIntf")
{
  m_kbconf = conf;
  current_group = 0;
}

KBSwitchIntf::~KBSwitchIntf(){
}

int KBSwitchIntf::getNumKbdGroups()
{
  return m_kbconf->groupCount();
}

ASYNC KBSwitchIntf::selectNextGroup()
{
  emit nextGroupSelected();
}

ASYNC KBSwitchIntf::selectGroup(int groupno)
{
  emit groupSelected(groupno);
}

QStringList KBSwitchIntf::getGroupNames()
{
  QStringList result;
  for (int i = 0; i < m_kbconf->groupCount(); i++)
    result.append(m_kbconf->getGroup(i)->getName());
  return result;
}

bool KBSwitchIntf::setLayout(const QString& layout)
{
  for (int i = 0; i < m_kbconf->groupCount(); i++)
  {
    if (m_kbconf->getGroup(i)->getLang() == layout)
    {
	selectGroup(i);
	return true;
    }
  }
  return false;
}

QStringList KBSwitchIntf::getLayoutsList()
{
  QStringList layouts;
  for (int i = 0; i < m_kbconf->groupCount(); i++)
    layouts.append(m_kbconf->getGroup(i)->getLang());
  return layouts;
}

QString KBSwitchIntf::getCurrentLayout()
{
  int group_count = m_kbconf->groupCount();
  for (int i = 0; i < group_count; i++)
  {
    if( i == current_group )
	return m_kbconf->getGroup(i)->getLang();
  }
  return "err";
}
